﻿using igGrid_Combo_Editor.Models;
using Microsoft.AspNetCore.Mvc;
using System.Diagnostics;
using Infragistics.Web.Mvc;

namespace igGrid_Combo_Editor.Controllers
{
    public class HomeController : Controller
    {
        //index view pass data as IEnumerable
        [GridDataSourceAction]
        public ActionResult Index()
        {
            var viewModel = new CustomersViewModel
            {
                //IEnumerable of Customer Objects
                Customers = GetCustomers(),
                Countries = GetCountries(),
                Jobs = GetJobs(),
            };
            return View(viewModel);
        }

        //get the customers
        private IEnumerable<Customer> GetCustomers()
        {
            return new List<Customer>
            {
                new Customer { ID=1, Name="John Smith", Job="Software Developer", Country="Bulgaria" },
                new Customer { ID=2, Name="Bob Richards", Job="Lawer", Country="France" },
                new Customer { ID=3, Name="Marge Wright", Job="Doctor", Country="Germany" },
                new Customer { ID=4, Name="Dwight Long", Job="Dealer", Country="Spain" },
                new Customer { ID=5, Name="Amy Grant", Job="Teacher", Country="Bulgaria" },
                new Customer { ID=6, Name="Jon Terry", Job="Footballer", Country="UK" },
            };
        }

        //get the counties AsQueryable
        public IQueryable<Country> GetCountries()
        {
            IQueryable<Country> data;
            IEnumerable<Country> temp = new List<Country>
            {
                new Country { Key="1", Value="Bulgaria"},
                new Country { Key="2", Value="USA"},
                new Country { Key="3", Value="Germany"},
                new Country { Key="4", Value="Spain"},
                new Country { Key="5", Value="UK"},
                new Country { Key="6", Value="France"},
            };
            data = temp.AsQueryable();

            return data;
        }

        //get the jobs AsQueryable
        public IQueryable<Job> GetJobs()
        {
            IQueryable<Job> data;
            IEnumerable<Job> temp = new List<Job>
            {
                new Job { Key="1", Value="Software Developer"},
                new Job { Key="2", Value="Lawer"},
                new Job { Key="3", Value="Doctor"},
                new Job { Key="4", Value="Dealer"},
                new Job { Key="5", Value="Teacher"},
                new Job { Key="6", Value="Housekeepr"},
                new Job { Key="7", Value="Worker"},
                new Job { Key="8", Value="Footballer"},
            };
            data = temp.AsQueryable();

            return data;
        }
    }
}